OPAM-SWITCH(1)

NAME

opam-switch - Manage multiple installation of compilers.

SYNOPSIS

opam switch [OPTION]... [COMMAND] [ARG]...

DESCRIPTION

This command allows one to switch between different compiler versions, installing the compiler if opam switch is used to switch to that compiler for the first time. The different compiler versions are totally independent from each other, meaning that OPAM maintains a separate state (e.g. list of installed packages...) for each.

See the documentation of opam switch list to see the compilers which are available, and how to switch or to install a new one.

COMMANDS

Without argument, defaults to list.

SWITCH
    With a SWITCH argument, defaults to set SWITCH.

install SWITCH
    Install the given compiler. The command fails if the switch is already installed (e.g. it will not transparently switch to the installed compiler switch, as with set).

set SWITCH
    Set the currently active switch, installing it if needed.

remove SWITCH
    Remove the given compiler.

export FILE
    Save the current switch state to a file.

import FILE
    Import a saved switch state.

reinstall SWITCH
    Reinstall the given compiler switch. This will also reinstall all packages.

list
    List compilers. By default, lists installed and `standard' compilers. Use `--all' to get the list of all installable compilers. The first column displays the switch name (if any), the second one the switch state (C = current, I = installed, -- = not installed), the third one the compiler name and the last one the compiler description. To switch to an already installed compiler alias (with state = I), use opam switch <name>. If you want to use a new compiler <comp>, use opam switch <comp>: this will download, compile and create a fresh and independent environment where new packages can be installed. If you want to create a new compiler alias (for instance because you already have this compiler version installed), use opam switch <name> --alias-of <comp>. In case <name> and <comp> are the same, this is equivalent to opam switch <comp>.

show
    Show the current compiler.

OPTIONS

-A COMP, --alias-of=COMP
    The name of the compiler description which will be aliased.

-a, --all
    List all the compilers which can be installed on the system.

-b, --keep-build-dir
    Keep the build directory. This is equivalent to setting $OPAMKEEPBUILDDIR to "true".

-d, --build-doc
    Build the package documentation. This is equivalent to setting $OPAMBUILDDOC to "true".

--dry-run
    Simulate the command, but don't actually perform any changes.

-e TAGS, --external=TAGS
    Display the external packages associated to the given tags.

--fake
    This option registers the actions into the OPAM database, without actually performing them. WARNING: This option is dangerous and likely to break your OPAM environment. You probably want `--dry-run'. You've been warned.

-i, --installed
    List installed compiler switches only.

-j JOBS, --jobs=JOBS
    Set the maximal number of concurrent jobs to use. You can also set it using the $OPAMJOBS environment variable.

--json=FILENAME
    Save the result output of an OPAM run in a computer-readable file

-m MAKE, --make=MAKE
    Use MAKE as the default 'make' command.

--no-checksums
    Do not verify the checksum of downloaded archives.This is equivalent to setting $OPAMNOCHECKSUMS to "true".

--no-switch
    Only install the compiler switch, without switching to it. If the compiler switch is already installed, then do nothing.

--no-warning
    Do not display any warning related to environment variables.

--require-checksums
    Reject the installation of packages that don't provide a checksum for the upstream archives. This is equivalent to setting $OPAMREQUIRECHECKSUMS to "true".

-s, --short
    Output the names separated by one whitespace instead of using the usual formatting.

--show-actions
    Call the solver and display the actions. Don't perform any changes.

-t, --build-test
    Build and run the package unit-tests. This is equivalent to setting $OPAMBUILDTEST to "true".

COMMON OPTIONS

These options are common to all commands.

--color=WHEN (absent=auto)
    Colorize the output. WHEN must be `always', `never' or `auto'.

--compat-mode-1.0
    Compatibility mode with OPAM 1.0

--criteria=CRITERIA
    Specify user preferences for dependency solving for this run. Overrides both $OPAMCRITERIA and $OPAMUPGRADECRITERIA. For details on the supported language, and the external solvers available, see http://opam.ocaml.org/doc/Specifying_Solver_Preferences.html. A general guide to using solver preferences can be found at http://www.dicosmo.org/Articles/usercriteria.pdf. The default value is -count(down),-count(removed),-notuptodate(solution),-count(new) for upgrades, and -count(removed),-notuptodate(request),-count(down),-notuptodate(changed),-count(changed),-notuptodate(solution) otherwise.

--cudf=FILENAME
    Debug option: Save the CUDF requests sent to the solver to FILENAME-<n>.cudf.

--debug
    Print debug message to stderr. This is equivalent to setting $OPAMDEBUG to "true".

--debug-level=LEVEL
    Like `--debug', but allows specifying the debug level (`--debug' sets it to 1). Equivalent to setting $OPAMDEBUG to a positive integer.

--git-version
    Print the git version if it exists and exit.

--help[=FMT] (default=pager)
    Show this help in format FMT (pager, plain or groff).

--no-base-packages
    Do not install base packages (useful for testing purposes). This is equivalent to setting $OPAMNOBASEPACKAGES to a non-empty string.

--no-self-upgrade
    OPAM will replace itself with a newer binary found at OPAMROOT/opam if present. This disables this behaviour.

-q, --quiet
    Be quiet when installing a new compiler.

--root=ROOT (absent=~/.opam)
    Use ROOT as the current root path. This is equivalent to setting $OPAMROOT to ROOT.

--safe
    Make sure nothing will be automatically updated or rewritten. Useful for calling from completion scripts, for example. Will fail whenever such an operation is needed ; also avoids waiting for locks, skips interactive questions and overrides the OPAMDEBUG variable.

--solver=CMD
    Specify the name of the external dependency solver. The default value is aspcud

--strict
    Fail whenever an error is found in a package definition or a configuration file. The default is to continue silently if possible.

--switch=SWITCH
    Use SWITCH as the current compiler switch. This is equivalent to setting $OPAMSWITCH to SWITCH.

--use-internal-solver, --no-aspcud
    Force use of internal heuristics, even if an external solver is available.

-v, --verbose
    Be more verbose. Show output of all sub-commands. This is equivalent to setting $OPAMVERBOSE to "true".

--version
    Show version information.

-y, --yes
    Disable interactive mode and answer yes to all questions that would otherwise be asked to the user. This is equivalent to setting $OPAMYES to "true".

ENVIRONMENT VARIABLES

OPAM makes use of the environment variables listed here. Boolean variables should be set to "0", "no" of "false" to disable, "1", "yes" or "true" to enable.

OPAMCOLOR, when set to always or never, sets a default value for the --color option.

OPAMCRITERIA specifies user preferences for dependency solving.The default value is -count(removed),-notuptodate(request),-count(down),-notuptodate(changed),-count(changed),-notuptodate(solution). See also option --criteria

OPAMCURL can be used to define an alternative for the 'curl' command-line utility to download files.

OPAMDEBUG see options `--debug' and `--debug-level'.

OPAMEXTERNALSOLVER see option `--solver'.

OPAMJOBS sets the maximum number of parallel workers to run.

OPAMNOASPCUD see option `--no-aspcud'.

OPAMNOSELFUPGRADE see option `--no-self-upgrade'.

OPAMROOT see option `--root'. This is automatically set by `opam config env --root=DIR' when DIR is non-default.

OPAMSOLVERTIMEOUT change the time allowance of the internal solver.

OPAMSWITCH see option `--switch'. Automatically set by `opam config env --switch=SWITCH'.

OPAMUPGRADECRITERIA specifies user preferences for dependency solving when performing an upgrade. Overrides OPAMCRITERIA in upgrades if both are set.The default value is -count(down),-count(removed),-notuptodate(solution),-count(new). See also option --criteria

OPAMUTF8MSGS use nice UTF8 characters in OPAM messages.

OPAMVERBOSE see option `--verbose'.

OPAMVAR_var overrides the contents of the variable var when substituting `%{var}%` strings in `opam` files.

OPAMVAR_package_var overrides the contents of the variable package:var when substituting `%{package:var}%` strings in `opam` files.

OPAMUSEINTERNALSOLVER see option `--use-internal-solver'.

OPAMYES see option `--yes'.

FURTHER DOCUMENTATION

See https://opam.ocaml.org.

AUTHORS

Thomas Gazagnaire <thomas@gazagnaire.org>

Anil Madhavapeddy <anil@recoil.org>

Fabrice Le Fessant <Fabrice.Le_fessant@inria.fr>

Frederic Tuong <tuong@users.gforge.inria.fr>

Louis Gesbert <louis.gesbert@ocamlpro.com>

Vincent Bernardoff <vb@luminar.eu.org>

Guillem Rieu <guillem.rieu@ocamlpro.com>

Roberto Di Cosmo <roberto@dicosmo.org>

BUGS

Check bug reports at https://github.com/ocaml/opam/issues.